From 4c4a1c3da640831d59cd98ca76a538a84b22a7bc Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Mon, 28 Nov 2011 10:04:42 -0600
Subject: UI now supports weighted mean EC

---
 grade/edit/tree/index.php |   15 ++++++++++++++-
 grade/edit/tree/lib.php   |    9 +++++++++
 2 files changed, 23 insertions(+), 1 deletions(-)

diff --git a/grade/edit/tree/index.php b/grade/edit/tree/index.php
index 8d88615..e1328f8 100644
--- a/grade/edit/tree/index.php
+++ b/grade/edit/tree/index.php
@@ -294,7 +294,20 @@ if ($data = data_submitted() and confirm_sesskey()) {
             $value = clean_param($value, PARAM_BOOL);
 
             $grade_item = grade_item::fetch(array('id'=>$aid, 'courseid'=>$courseid));
-            $grade_item->aggregationcoef = $value;
+
+            // Weighted Mean special case
+            $parent = $grade_item->load_parent_category();
+            if ($parent->aggregation == GRADE_AGGREGATE_WEIGHTED_MEAN) {
+                $oldcoef = $grade_item->aggregationcoef;
+
+                if ($oldcoef < 0 and !$value) {
+                    $grade_item->aggregationcoef = 0;
+                } else {
+                    $grade_item->aggregationcoef = $value ? -1 : $oldcoef;
+                }
+            } else {
+                $grade_item->aggregationcoef = $value;
+            }
 
             $grade_item->update();
             grade_regrade_final_grades($courseid);
diff --git a/grade/edit/tree/lib.php b/grade/edit/tree/lib.php
index 49af487..9e2a09f 100644
--- a/grade/edit/tree/lib.php
+++ b/grade/edit/tree/lib.php
@@ -366,12 +366,21 @@ class grade_edit_tree {
 
         if ((($aggcoef == 'aggregationcoefweight' || $aggcoef == 'aggregationcoef') && $type == 'weight') ||
             ($aggcoef == 'aggregationcoefextraweight' && $type == 'extra')) {
+
+            if ($aggcoef == 'aggregationcoefweight' && $item->aggregationcoef < 0) {
+                return '';
+            }
+
             return '<input type="text" size="6" id="aggregationcoef_'.$item->id.'" name="aggregationcoef_'.$item->id.'"
                 value="'.grade_edit_tree::format_number($item->aggregationcoef).'" />';
         } elseif ($aggcoef == 'aggregationcoefextrasum' && $type == 'extra') {
             $checked = ($item->aggregationcoef > 0) ? 'checked="checked"' : '';
             return '<input type="hidden" name="extracredit_'.$item->id.'" value="0" />
                     <input type="checkbox" id="extracredit_'.$item->id.'" name="extracredit_'.$item->id.'" value="1" '."$checked />\n";
+        } elseif ($aggcoef == 'aggregationcoefweight' && $type == 'extra') {
+            $checked = ($item->aggregationcoef < 0) ? 'checked="checked"' : '';
+            return '<input type="hidden" name="extracredit_'.$item->id.'" value="0" />
+                    <input type="checkbox" id="extracredit_'.$item->id.'" name="extracredit_'.$item->id.'" value="1" '."$checked />\n";
         } else {
             return '';
         }
-- 
1.7.1


